#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include "srcp.h"

int main(int argc, char **argv)
{
	struct srcp_accessory_dcc acc;
	struct srcp *srcp;
	int response;
	
	if (argc < 5) {
		printf("Usage: %s [host] [address] [port] [value]\n",
		    argv[0]);
		return 1;
	}
	
	srcp = srcp_create(argv[1], "4303");
	if (!srcp) {
		perror("srcp_create()");
		return 1;
	}

	srcp_go(srcp);

	acc.bus = 1;
	acc.address = atoi(argv[2]);

	response = srcp_accessory_dcc_get(srcp, &acc);
	if (SRCP_RESPONSE_ERROR(response)) {
		printf("Initializing new accessory\n");
		srcp_accessory_dcc_init(srcp, &acc);
	} else {
		printf("Accessory already known\n");
	}

	srcp_accessory_dcc_set(srcp, &acc, atoi(argv[3]), atoi(argv[4]));

	return 0;
}
