#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#include "srcp.h"

int main(int argc, char **argv)
{
	struct srcp *srcp;
	int r = 0;
	int bus, address, cv, value;
	
	if (argc < 6) {
		printf("Usage: %s [host] [bus] [address] [cv] [value]\n", argv[0]);
		return 1;
	}
	bus = atoi(argv[2]);
	address = atoi(argv[3]);
	cv = atoi(argv[4]);
	value = atoi(argv[5]);
	
	srcp = srcp_create(argv[1], "4303");
	if (!srcp) {
		perror("srcp_create()");
		return 1;
	}

	srcp_connectionmode_set(srcp, SRCP_CONNECTIONMODE_COMMAND);

	srcp_go(srcp);

	r = srcp_sm_init(srcp, bus);
	if (SRCP_RESPONSE_ERROR(r)) {
		printf("SRCP error initializing service mode: %d\n", r);
	}

	r = srcp_sm_set_cv(srcp, bus, address, cv, value);
	if (SRCP_RESPONSE_ERROR(r)) {
		printf("SRCP error setting CV: %d\n", r);
	}

	r = srcp_sm_term(srcp, bus);
	if (SRCP_RESPONSE_ERROR(r)) {
		printf("SRCP error terminating service mode: %d\n", r);
	}


	return 0;
}

