#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include "srcp.h"

static void srcp_console_status(struct srcp_loc_dcc *loc)
{
	printf("%s %03d/%03d %c%c%c%c%c\n",
	    loc->drivemode == SRCP_LOC_DCC_DRIVEMODE_FORWARD ? "Forward" : "Backward",
	    loc->V, loc->V_max,
	    loc->functions[0] ? 'o' : '.',
	    loc->functions[1] ? 'o' : '.',
	    loc->functions[2] ? 'o' : '.',
	    loc->functions[3] ? 'o' : '.',
	    loc->functions[4] ? 'o' : '.'
	);
}

int main(int argc, char **argv)
{
	struct srcp_loc_dcc loc;
	struct srcp *srcp;
	int response;
	
	if (argc < 3) {
		printf("Usage: %s [host] [address]\n",
		    argv[0]);
		return 1;
	}
	
	srcp = srcp_create(argv[1], "4303");
	if (!srcp) {
		perror("srcp_create()");
		return 1;
	}

	srcp_go(srcp);

	loc.bus = 1;
	loc.address = atoi(argv[2]);

	response = srcp_loc_dcc_get(srcp, &loc);
	if (SRCP_RESPONSE_ERROR(response)) {
		printf("Could not get loc values, srcp response: %d\n", response);
		return 1;
	}

	srcp_console_status(&loc);

	return 0;
}
