#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#include "srcp.h"

static void loc_dcc_init_hook(struct srcp *srcp, struct srcp_loc_dcc *loc)
{
	printf("New loc: %d\n", loc->address);
	srcp_loc_dcc_put(loc);
}

static void all_hook(struct srcp *srcp, char *message)
{
	printf("recv: %s", message);
}

int main(int argc, char **argv)
{
	struct srcp *srcp;
	int r = 0;
	bool error = false;
	
	if (argc < 2) {
		printf("Usage: %s [host]\n", argv[0]);
		return 1;
	}
	
	srcp = srcp_create(argv[1], "4303");
	if (!srcp) {
		perror("srcp_create()");
		return 1;
	}
	srcp_hook_all(srcp, all_hook);

	srcp_connectionmode_set(srcp, SRCP_CONNECTIONMODE_INFO);

	srcp_hook_loc_dcc_init(srcp, loc_dcc_init_hook);

	srcp_go(srcp);

	while (!error) {
		r = srcp_info_handle(srcp);
		error = SRCP_RESPONSE_ERROR(r);
	}
	printf("SRCP error code: %d\n", r);

	return 0;
}

